/*
	Klasse som brukes til  sette opp vertex'er for
	hydekartet
*/


public class HeightField 
{
	private int SIZE; 	//bredde i av omrdet(kvadratisk)
	
	private float stride;
	
	//Array som innholder innformasjon 
	//om punkter i x, y og z retning
	private float[][][] flate;

	//Array som innholder innformasjon 
	//om teksturkooridnater i x og y retning
	private float[][][] teksturkoor;
	
	private float[] vertices;
	
	//Konstruktr for  initaliere klassen
	public HeightField(int Size, float stride, float texrep)
	{
		SIZE = Size;
		flate = new float[SIZE][SIZE][3];
		teksturkoor = new float[SIZE][SIZE][2]; 
		setData(stride, texrep);
		this.stride = stride;
	}
	
	//Metode for  sette opp en SIZEx * SIZEy flate
	//stride er mellomrom mellom punkter
	private void setData(float stride, float teksrep)
	{
		float x = 0.0f;
		float y = 0.0f;
		
		float hopp = (1.0f/(float)SIZE)*teksrep;
		float u = 0.0f;
		float v = 0.0f;
		
		//Alle y-koordinater
		for (int breddeX = 0; breddeX <= SIZE-1; breddeX++)
		{
			//Alle x-koordinater for en y-verdi
			for (int breddeY = 0; breddeY <= SIZE-1; breddeY++)
			{
				//Setter y verdi
				flate[breddeX][breddeY][0] = x;
				//Setter x verdi
				flate[breddeX][breddeY][1] = y;
				//Setter z verdi (hyde) til 0, 
				//legger ikke inn hyder enda
				flate[breddeX][breddeY][2] = 0.0f;
				
				x += stride;
				
				//Tekstur x koordinat
				teksturkoor[breddeX][breddeY][0] = u;
				//Tekstur y koordinat
				teksturkoor[breddeX][breddeY][1] = v;
				
				u += hopp;
			}
			v += hopp;
			u = 0.0f;
			
			x = 0.0f;
			y += stride;
		}
	}
	
	//Metode for  f tak i hydekart koordinater
	public float[][][] getData()
	{
		return flate;
	}
	
	//Metode for  f lengde i punktet (x,y)
	public float getLength(int x, int y)
	{
		return flate[x][y][0];
	}
	
	//Metode for  f bredde i punktet (x,y)
	public float getWidth(int x, int y)
	{
		return flate[x][y][1];
	}
	
	//Metode for  f hyden i punktet (x,y)
	public float getHeight(int x, int y)
	{
		return flate[x][y][2];
	}
	
	//Metode for  sette hyden i punktet (x,y)
	public void setHeight(int x, int y, float verdi)
	{
		flate[x][y][2] = verdi;
	}
	
	//Metode for  hente ut teksturkoordinater
	public float[][][] getTeksturKoor()
	{
		return teksturkoor;
	}

	//Metode for  hente ut hydekartets strrelse
	public int getSize()
	{
		return SIZE;
	}

	//Metode for  hente ut hydekartets stride
	public float getStride() {return stride;}
}

