/*
Klasse som genererer en tekstur med 
sn p toppen av fjellene, fjell p fjellsidene,
og gress p de laveste punktene
*/
public class Texture
{
	HeightField hf;
	//Array til  lagre tekstur verdier
	float[] texture;
	
public Texture(HeightField h, float heightdiff, float s, float f)
{
	hf = h;
	//Fire verdier for hver pixel R(ed) G(reen) B(lue) A(lpha)
	texture = new float[hf.getSize()*hf.getSize()*4];
	makeTexture(heightdiff, s, f);
}

public void makeTexture(float hd, float prosentsno, float prosentfjell)
{
	int v = 0;
	
	//Antall prosent sn (topp)
	float psno = hd * prosentsno;
	//Antall prosent fjell (midt)
	float pfjell = hd * prosentfjell;

	//G igjennom alle punkter i hydekart
	for (int i = 0; i < hf.getSize(); i++)
	{
		for (int j = 0; j < hf.getSize(); j++)
		{
			//Hvis hyde strre en minste verdi for sn
			if (hf.getHeight(i,j) > (hd - psno))
			{
				//Hvit tekstur
				texture[v] = 1.0f;
				texture[v+1] = 1.0f;
				texture[v+2] = 1.0f;
				texture[v+3] = 1.0f;
			}
			//Hvis hyde innefor fjellomrde
			else if ((hf.getHeight(i,j) < (hd - psno)) && (hf.getHeight(i,j) > (hd - (psno+pfjell))))
			{
				//Brunaktig tekstur
				texture[v] = 0.9f;
				texture[v+1] = 0.9f;
				texture[v+2] = 0.5f;
				texture[v+3] = 1.0f;
			}
			//Hvis hyde mindre en fjell
			else 
			{
				//Grnn og svart tekstur
				texture[v] = 0.0f;
				texture[v+1] = (float)Math.random()*0.8f;
				texture[v+2] = 0.0f;
				texture[v+3] = 1.0f;
			}
			v += 4;
		}
	}
}

//Hent ut tekstur
public float[] getTexture()
{
	return texture;
}

}

